package de.hsrm.ads;

import java.util.Iterator;

public class BinTreeWithIterator<T> implements Iterable<T> {

	Node root;

	class Node {

		Node left;
		Node right;
		T value;

		Node(T value) {
			this.value = value;
		}

		Node(T value, Node left, Node right) {
			this.value = value;
			this.left = left;
			this.right = right;
		}
		
	}

	public BinTreeWithIterator() {
		// FIXME
	}

	public static void main(String[] args) {
		BinTreeWithIterator<String> tree = new BinTreeWithIterator<String>();
		tree.root = tree.new Node("Winter");
		tree.root.left = tree.new Node("is");
		tree.root.right = tree.new Node("coming.");
		// should print "Winter \n is \n coming."
		for (String s : tree) {
			System.out.println(s);
		}
	}

	
}
